﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Load and calculate N_bypass
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function load_calc_SP2_bypass(save_rate,m_star,flowrate, datew)
	//where save rate is for example, 1/10 or 1/1
	//flowrate is in cm3/min
	variable save_rate
	variable flowrate
	variable datew
	wave m_star
	LoadWave/O/J/M/D/N=SP2_bypass_data/K=0/L={0,1,0,0,0}
	wave SP2_bypass_data0
	make/O/N=(dimsize(SP2_bypass_data0,0)) SP2_bypass_mass=0 //extract the mass and time vectors of the bypass into a new wave
	make/O/N=(dimsize(SP2_bypass_data0,0)) SP2_bypass_time=0
	SP2_bypass_mass = SP2_bypass_data0[p][1]	
	SP2_bypass_time  = SP2_bypass_data0[p][0]-datew //why do we lose accuracy with large numbers? 
	
	wave wOut = mylogspace(m_star[0],m_star[numpnts(m_star)-1],(numpnts(m_star)*5)) //Logrithmically spaced bins because it looks nicer, dont really have to
	
	//print wOut
	duplicate/O wOut setEdgesForBypass
	killwaves wOut
	//print setEdgesForBypass
	make/O/N=(numpnts(setEdgesForBypass)) m_upper
	make/O/N=(numpnts(setEdgesForBypass)) m_lower
	m_upper = setEdgesForBypass
	m_lower = setEdgesForBypass
	deletepoints 0,1,m_upper
	deletepoints (numpnts(setEdgesForBypass)-1),1,m_lower //calculated the upper and lower bins
	
	//There is no command to make logrithmically spaced binned histogram. So this double loop does that by counting the number of particles in each bin
	make/O/N=(numpnts(setEdgesForBypass)-1) N_SP2_bypass_mass=0
	variable kk,jj
		for (jj=0;jj<numpnts(setEdgesForBypass)-1;jj+=1)
			for (kk=0;kk<numpnts(SP2_bypass_mass);kk+=1)
				if ((SP2_bypass_mass[kk]>m_lower[jj]) & (SP2_bypass_mass[kk]<m_upper[jj]))
					N_SP2_bypass_mass[jj]+=1 
				endif
			endfor
		endfor
	
	//calculate time of bypass scan
	variable time_CPMA
	time_CPMA =   abs(SP2_bypass_data0[0] - SP2_bypass_data0[dimsize(SP2_bypass_data0,0)-1]) //abs(wavemax(SP2_bypass_time) - wavemin(SP2_bypass_time))
	make/O/N=(numpnts(N_SP2_bypass_mass)) dNdlogmrBC_bypass=N_SP2_bypass_mass
	
	//calculate dN/dlogmp by dividing number by scan time and flowrate, then dividing by log(m_upper/m_lower)
	print m_upper
	print m_lower
	dNdlogmrBC_bypass = dNdlogmrBC_bypass/(time_CPMA*flowrate/60)/log(m_upper/m_lower)/save_rate //NOTE THE SAVE RATE HERE!!!!
	
	print time_CPMA
	//print SP2_bypass_time
	display dNdlogmrBC_bypass vs setEdgesForBypass
	ModifyGraph mode=5,useNegRGB=1,usePlusRGB=1,hbFill=2,useNegPat=1,hBarNegFill=2;DelayUpdate
	ModifyGraph log(bottom)=1
	Label left "dN/dlogm\\BrBC"
	Label bottom "m\\BrBC"
	
	//calculate the total number concentration
	variable N_bypass
	make/O/N=(numpnts(N_SP2_bypass_mass)) temp_wave =0
	temp_wave=dNdlogmrBC_bypass*log(m_upper/m_lower)
	N_bypass = sum(temp_wave)
	print N_bypass
	
	return N_bypass
	
end
