#pragma rtGlobals=1		// Use modern global access method and strict wave access.

function cereal_killer() //delete all user created constructs in order to test from scratch
kill_graphs_and_tables()
killvariables/A/Z
killwaves/A/Z
end


function load_constants()
	variable/G T_neut, max_charge, electric_charge_constant, Dm, C,flowrate, omega_hat,Pressure,Temperature, flowrate_CPMA
	T_neut = 295;      //neutral Temperature
	max_charge = 3;   //%maximum charge possible on particle
	electric_charge_constant=1.602*10^-19;    //  %electrical charge on particle
	Dm = 2.49;  // fractal dimension
	C = 0.131*pi/6;	//density factor
	flowrate = 120 // cm3/min
	omega_hat = 1/1.03125
	//Pressure = 0.896099679249938 //kPa
	//Temperature = 300.04 //K
	//flowrate_CPMA = 1.866666666666667e-05 //  m3 s-1
end


Function/D Median2(w)
	wave w
	variable result

	Duplicate/O w, temp
	sort temp, temp
	result = temp[numpnts(temp)/2]
	
	Killwaves temp
	
	return result
	
end

//Function/WAVE linspace2(wIn,X1,X2,n_pts)
//    Wave wIn
//    Variable X1,X2,n_pts
//    Variable step_size= abs((X2-X1)/(n_pts-1))
//    string newName = Nameofwave(wIn)+"_out"
//    Duplicate/O wIn, $newName
//    
//    wave wOut= $newName
//    Redimension/N=(n_pts) wOut
//    variable ii = 0
//    
//    for (ii=0;ii<n_pts;ii+=1)
//   	 wOut[ii] = X1 + (ii)*(X2 - X1)/(n_pts-1)   
//    endfor
//    
//    print wOut
//    return wOut
//End

Function/WAVE linspace(X1,X2,n_pts)
    Variable X1,X2,n_pts
    Variable step_size= abs((X2-X1)/(n_pts-1))
    string newName = Nameofwave(wIn)+"_out"
    make/O/N=(n_pts) wOut
    
    variable ii = 0
    
    for (ii=0;ii<n_pts;ii+=1)
   	 wOut[ii] = X1 + (ii)*(X2 - X1)/(n_pts-1)   
    endfor

    return wOut
End

Function/WAVE myLogSpace(X1,X2,n_pts)
    Variable X1,X2,n_pts
	
	make/O/N=(n_pts) wOut
	wave temp = linspace(log(X1),log(x2),n_pts)
	
	wOut = 10^temp

    return wOut
End



//function test_loglinspace()
//
//	make/O/N=10 linspace_test
//	make/O/N=10 logspace_test
//	 wave wOut = linspace(1,10,10)
//	 linspace_test=wOut
//	 print linspace_Test
//	wave wOut= myLogSpace(1,10,10)
//	logspace_test=wOut
//	print logspace_test
//	
//end

//Function CallMe2()
	//make/O junk
	//Wave wOut =  linspace2(1,5,5) // wave reference to free wave
	//print wOut
//End

//Function/Wave DoTest()
//	Make/FREE data = p
//	return data // returning free wave
//End
// 
//Function CallMe()
//	Wave data =  DoTest() // wave reference to free wave
//	print data
//	return NaN // no more references to the wave "data", data will be deleted
//End

Function MDsort(w,keycol, [reversed])
	Wave w
	variable keycol, reversed
 
	variable type
 
	type = Wavetype(w)
 
	make/Y=(type)/free/n=(dimsize(w,0)) key
	make/free/n=(dimsize(w,0)) valindex
 
	if(type == 0)
		Wave/t indirectSource = w
		Wave/t output = key
		output[] = indirectSource[p][keycol]
	else
		Wave indirectSource2 = w
		multithread key[] = indirectSource2[p][keycol]
 	endif
 
	valindex=p
 	if(reversed)
 		sort/a/r key,key,valindex
 	else
		sort/a key,key,valindex
 	endif
 
	if(type == 0)
		duplicate/free indirectSource, M_newtoInsert
		Wave/t output = M_newtoInsert
	 	output[][] = indirectSource[valindex[p]][q]
	 	indirectSource = output
	else
		duplicate/free indirectSource2, M_newtoInsert
	 	multithread M_newtoinsert[][] = indirectSource2[valindex[p]][q]
		multithread indirectSource2 = M_newtoinsert
 	endif 
End


// Kill all the graphs
Function KillAllGraphs()
	string fulllist = WinList("*", ";","WIN:1")
	string name, cmd
	variable i
 
	for(i=0; i<itemsinlist(fulllist); i +=1)
		name= stringfromlist(i, fulllist)
		sprintf  cmd, "Dowindow/K %s", name
		execute cmd		
	endfor
end

function kill_graphs_and_tables()
	string object_name
	variable string_length
	do
		object_name = WinName(0,3)			// name of top graph or table  (see III-441)
		string_length = strlen(object_name)	        // returns "" if no graph/table is present	
		if (string_length == 0)
			break
		endif
		DoWindow /K $object_name			// kill top graph or table; keep going till all done
	while (1)                                                            // loop forever until break		
end

