#pragma rtGlobals=1		// Use modern global access method and strict wave access.


function calculateNfromTwoVarDist(wave2Dinput, xVal, yVal)
	wave wave2Dinput, yVal, xVal
	duplicate/O wave2Dinput wave2D
	//make sure the rBC and mp points matrix is a "wave" for integration
	make/O/N=(numpnts(yVal)) mBC
	mBC=yVal
	
	make/O/N=(numpnts(xVal)) mp
	mp = xVal
	
	//create array of m_bins the same size as wave2D (so we can multiply them together)
	make/O/N=(dimsize(wave2D,0),dimsize(wave2D,1)) wave2Dmp
	variable ii=0, jj=0
	for(ii=0;ii<dimsize(wave2D,0);ii+=1)
		wave2Dmp[ii][]=mp[q] 
	endfor
	
	//create array of mrBC (midpoints, the same size as wave 2D
	make/O/N=(dimsize(wave2D,0),dimsize(wave2D,1)) wave2Dmidpoints
	for(ii=0;ii<dimsize(wave2D,1);ii+=1)
		wave2Dmidpoints[][ii]=mBC[p] 
	endfor
	
	
	make/O/N=(dimsize(wave2D,0),dimsize(wave2D,1)) intermediateWave2D
	//calculate dNdlogmp		
		intermediateWave2D = wave2D/wave2Dmidpoints //for integration
		//make/O/N=28 testresult
		integrate/DIM=0/T intermediateWave2D /X=mBC /D=intermediateResult
		make/O/N=((numpnts(mp))) dNdlogmp
		dNdlogmp = intermediateResult[dimsize(intermediateResult,0)][p]
		intermediateWave2D = 0
		intermediateResult=0
		
		//Calculate N_total 
		make/O/N=(numpnts(mp)) intermediateWave1D
		intermediateWave1D = dNdlogmp/mp //for integration
		integrate/DIM=0/T intermediateWave1D /X=mp /D=intermediateResult
		variable N_total
		N_total = intermediateResult[numpnts(intermediateResult)] //because the result of integrate() is a vector
		intermediateWave1D = 0
		intermediateResult=0
		variable N_total_bypass=N_total
		return N_total_bypass
	
	
		killwaves wave2D, intermediateWave1D, intermediateWave2D, wave2Dmp, wave2Dmidpoints, intermediateResult


end


function integrate2DDistribution(wave2Dinput, xVal, yVal)
	wave wave2Dinput, yVal, xVal
	duplicate/O wave2Dinput wave2D
	//make sure the rBC and mp points matrix is a "wave" for integration
	make/O/N=(numpnts(yVal)) mBC
	mBC=yVal
	
	make/O/N=(numpnts(xVal)) mp
	mp = xVal
	
	
	//create array of m_bins the same size as wave2D (so we can multiply them together)
	make/O/N=(dimsize(wave2D,0),dimsize(wave2D,1)) wave2Dmp
	variable ii=0, jj=0
	for(ii=0;ii<dimsize(wave2D,0);ii+=1)
		wave2Dmp[ii][]=mp[q] 
	endfor
	
	//create array of mrBC (midpoints, the same size as wave 2D
	make/O/N=(dimsize(wave2D,0),dimsize(wave2D,1)) wave2Dmidpoints
	for(ii=0;ii<dimsize(wave2D,1);ii+=1)
		wave2Dmidpoints[][ii]=mBC[p] 
	endfor
	
//NUMBER DISTRIBUTIONS	
make/O/N=(dimsize(wave2D,0),dimsize(wave2D,1)) intermediateWave2D
	//calculate dNdlogmp		
		intermediateWave2D = wave2D/wave2Dmidpoints //for integration
		//make/O/N=28 testresult
		integrate/DIM=0/T intermediateWave2D /X=mBC /D=intermediateResult
		make/O/N=((numpnts(mp))) dNdlogmp
		dNdlogmp = intermediateResult[dimsize(intermediateResult,0)][p]
		intermediateWave2D = 0
		intermediateResult=0
		
	//calculate dNdlogmrBC
		intermediateWave2D = wave2D/wave2Dmidpoints
		integrate/DIM=1/T intermediateWave2D /X=mp /D=intermediateResult
		make/O/N=((numpnts(mBC))) dNdlogmrBC
		dNdlogmrBC = intermediateResult[p][dimsize(intermediateResult,1)]
		intermediateWave2D = 0
		intermediateResult=0
		
	//Plot the number distributions	
		duplicate/O mp mp_infg
		duplicate/O mBC mBC_in_fg
		mp_infg*=1e18
		mBC_in_fg*=1e18
		plotNumberDistributions(mp_infg,dNdlogmp, mBC_in_fg, dNdlogmrBC)
	
//MASS DISTRIBUTIONS
	//dMrBC/dlogmrBC
		intermediateWave2D = wave2D*wave2Dmidpoints/wave2Dmp //for integration
		integrate/DIM=1/T intermediateWave2D /X=mp /D=intermediateResult
		make/O/N=((numpnts(mBC))) dMrBCdlogmrBC
		dMrBCdlogmrBC = intermediateResult[p][dimsize(intermediateResult,1)]
		intermediateWave2D = 0
		intermediateResult=0
		
	//dM/dlogmrBC
		intermediateWave2D = wave2D //for integration
		integrate/DIM=1/T intermediateWave2D /X=mp /D=intermediateResult
		make/O/N=((numpnts(mBC))) dMdlogmrBC
		dMdlogmrBC = intermediateResult[p][dimsize(intermediateResult,1)]
		intermediateWave2D = 0
		intermediateResult=0
		
	//dMp/dlogmp
		intermediateWave2D = wave2D*wave2Dmp/wave2Dmidpoints //for integration
		integrate/DIM=0/T intermediateWave2D /X=mBC /D=intermediateResult
		make/O/N=((numpnts(mp))) dMdlogmp
		dMdlogmp = intermediateResult[dimsize(intermediateResult,0)][p]
		intermediateWave2D = 0
		intermediateResult=0
		
	//dMrBC/dlogmp
		intermediateWave2D = wave2D //for integration
		integrate/DIM=0/T intermediateWave2D /X=mBC /D=intermediateResult
		make/O/N=((numpnts(mp))) dMrBCdlogmp
		dMrBCdlogmp = intermediateResult[dimsize(intermediateResult,0)][p]
		intermediateWave2D = 0
		intermediateResult=0
		
		plotMassDistVsTotalMass(mp_infg, dMdlogmp,dMrBCdlogmp)
		plotMassDistVsBCMass(mBC_in_fg, dMdlogmrBC,dMrBCdlogmrBC)
	
//Calculate M_rBC and M_total
	//M_total
		make/O/N=(numpnts(mBC)) intermediateWave1D
		intermediateWave1D = dMdlogmrBC/mBC //for integration
		integrate/DIM=0/T intermediateWave1D /X=mBC /D=intermediateResult
		variable M_total
		M_total = intermediateResult[numpnts(intermediateResult)] //because the result of integrate() is a vector
		intermediateWave1D = 0
		intermediateResult=0
	
	//M_rBC_total
		intermediateWave1D = dMrBCdlogmrBC/mBC //for integration
		integrate/DIM=0/T intermediateWave1D /X=mBC /D=intermediateResult
		variable M_rBC_total
		M_rBC_total = intermediateResult[numpnts(intermediateResult)] //because the result of integrate() is a vector
		intermediateWave1D = 0
		intermediateResult=0
		
		variable M_rBC_totalugm3 = M_rBC_total*1e15, M_totalugm3 = M_total*1e15
		
		print M_rBC_totalugm3, M_totalugm3
		
		
//Calculate N_total 
		make/O/N=(numpnts(mp)) intermediateWave1D
		intermediateWave1D = dNdlogmp/mp //for integration
		integrate/DIM=0/T intermediateWave1D /X=mp /D=intermediateResult
		variable N_total
		N_total = intermediateResult[numpnts(intermediateResult)] //because the result of integrate() is a vector
		intermediateWave1D = 0
		intermediateResult=0
		print N_total
		
		killwaves wave2D, intermediateWave1D, intermediateWave2D, wave2Dmp, wave2Dmidpoints, intermediateResult
		
		
		
end


function plotMassDistVsBCMass(mBC, dMdlogmrBC,dMrBCdlogmrBC)
	wave mBC, dMdlogmrBC,dMrBCdlogmrBC
	
	//convert mass distribution from kg cm^3 to ug m^3
	duplicate/O dMdlogmrBC dMdlogmrBC_ugm3
	duplicate/O dMrBCdlogmrBC dMrBCdlogmrBC_ugm3
	dMdlogmrBC_ugm3*=1e15
	dMrBCdlogmrBC_ugm3*=1e15
	
	Display dMdlogmrBC_ugm3 vs mBC
	AppendToGraph dMrBCdlogmrBC_ugm3 vs mBC

	//modify the axis
	ModifyGraph log(bottom)=1,tick=2,mirror=1,axisOnTop=1,standoff=0;DelayUpdate
	Label left "d\\f02M\\f00/dlog\\f02m\\f00\\BrBC\\M \\f00(\\f02μ\\f00g m\\S-3\\M)";DelayUpdate
	Label bottom "\\f02m\\f00\\BrBC \\M(fg)";DelayUpdate
	SetAxis/A/N=1 left;DelayUpdate
	SetAxis/A/N=1 bottom
	
	//add a legend
	Legend/C/N=text0/J "\\s(dMdlogmrBC_ugm3) dM/dlogm\\BrBC\r\\s(dMrBCdlogmrBC_ugm3) \\Md\\f02M\\f00\\BrBC\\M\\f00/dlog\\f02m\\f00\\BrBC"	
	
	//modify the lines to match the paper
	ModifyGraph mode=4,msize=3,rgb=(0,0,0),marker(dMrBCdlogmrBC_ugm3)=8,marker(dMdlogmrBC_ugm3)=5,lstyle(dMdlogmrBC_ugm3)=7
	
end


function plotMassDistVsTotalMass(mp, dMdlogmp,dMrBCdlogmp)
	wave mp, dMdlogmp,dMrBCdlogmp
	
	//convert mass distribution from kg cm^3 to ug m^3
	duplicate/O dMdlogmp dMdlogmp_ugm3
	duplicate/O dMrBCdlogmp dMrBCdlogmp_ugm3
	dMdlogmp_ugm3*=1e15
	dMrBCdlogmp_ugm3*=1e15
	
	Display dMdlogmp_ugm3 vs mp
	AppendToGraph dMrBCdlogmp_ugm3 vs mp

	//modify the axis
	ModifyGraph log(bottom)=1,tick=2,mirror=1,axisOnTop=1,standoff=0;DelayUpdate
	Label left "d\\f02M\\f00/dlog\\f02m\\f00\\Bp\\M \\f00(\\f02μ\\f00g m\\S-3\\M)";DelayUpdate
	Label bottom "\\f02m\\f00\\Bp \\M(fg)";DelayUpdate
	SetAxis/A/N=1 left;DelayUpdate
	SetAxis/A/N=1 bottom
	
	//add a legend
	Legend/C/N=text0/J "\\s(dMdlogmp_ugm3) dM/dlogm\\Bp\r\\s(dMrBCdlogmp_ugm3) \\Md\\f02M\\f00\\BrBC\\M\\f00/dlog\\f02m\\f00\\Bp"	
	
	//modify the lines to match the paper
	ModifyGraph mode=4,msize=3,rgb=(0,0,0),marker(dMrBCdlogmp_ugm3)=8,marker(dMdlogmp_ugm3)=5,lstyle(dMdlogmp_ugm3)=7
	
end

function plotNumberDistributions(mp,dNdlogmp, mrBC, dNdlogmrBC )
	wave mp,dNdlogmp, mrBC, dNdlogmrBC 
	

	
	//create graph
	Display dNdlogmp vs mp
	AppendToGraph dNdlogmrBC vs mrBC

	//modify the axis
	ModifyGraph log(bottom)=1,tick=2,mirror=1,axisOnTop=1,standoff=0;DelayUpdate
	Label left "d\\f02N\\f00/dlog\\f02m\\M \\f00(cm\\S-3\\M)";DelayUpdate
	Label bottom "\\f02m\\f00\\Bp \\M(fg)";DelayUpdate
	SetAxis/A/N=1 left;DelayUpdate
	SetAxis/A/N=1 bottom
	
	//add a legend
	Legend/C/N=text0/J/F=0/B=(61166,61166,61166) "\\s(dNdlogmp) dN/dlogm\\Bp\r\\s(dNdlogmrBC) \\Md\\f02N\\f00/dlog\\f02m\\f00\\BrBC"
	
	//modify the lines to match the paper
	ModifyGraph mode=4,msize=3,rgb=(0,0,0),marker(dNdlogmp)=8,marker(dNdlogmrBC)=5,lstyle(dNdlogmrBC)=7
	
end



//Plotting function
function plotTwoVariableDistribution(twoVariableDistribution, binX, binY)
	wave twoVariableDistribution, binX, binY
	
	//Make the one to one line, for the extent of our data
	Make/O/N=2 onetwoY //make the yvalues of the waves
	Make/O/N=2 onetwoX //make the xvalues of the waves
	onetwoY[0] = wavemin(binY)
	onetwoY[1] = wavemax(binY)
	// a one to one line, set the x values the same as the y values
	onetwoX[0] = onetwoY[0]
	onetwoX[1] = onetwoY[1]
	
	Display /W=(200,200,900,800)/VERT onetwoX vs onetwoY
	AppendImage twoVariableDistribution vs {binY,binX}
	ModifyImage ''#0 ctab= {*,*,Rainbow256,1} //refer to matrix data source rather than image name? Quirk of IGOR...
	//colorscale
	//ColorScale/C/N=text0  ctab={0,100,Rainbow256,1},axisRange={,100}
	ModifyGraph lSize=5
	ModifyGraph lStyle=8
	ModifyGraph rgb=(65535,65535,65535)
	ModifyGraph log=1
	ModifyGraph tick=2
	ModifyGraph mirror=1
	ModifyGraph fSize=20
	ModifyGraph fStyle=1
	ModifyGraph lblMargin(left)=5,lblMargin(bottom)=18
	ModifyGraph standoff=0 
	ModifyGraph axThick=2
	ModifyGraph lblLatPos(left)=16,lblLatPos(bottom)=15
	ModifyGraph axisOnTop=1
	Label left "\\F'Helvetica'\\Z24\\f02m\\B\\f00p \\M \\Z24 (fg)"
	Label bottom "\\F'Helvetica'\\Z24\\f02m\\B\\f00rBC \\M \\Z24 (fg)"
	SetAxis left 1,100
	SetAxis bottom 1,100
	ColorScale/C/N=text0/D={2,1,0}/A=LT/X=3.97/Y=2.24 image=dN2_dlog_mp_rBC_realBins
	ColorScale/C/N=text0 frame=2, heightPct=35, widthPct=5, tickThick=2, fsize=18
	ColorScale/C/N=text0 fstyle=1, logLTrip=0.1, notation=1, axisRange={,100}
	ColorScale/C/N=text0 axisRange={,*}
	AppendText "\\F'Helvetica'\\Z24\\M \\Z24cm\\S-6"
	ModifyGraph swapXY=1
	ModifyGraph fSize=18
	
end




////////////////////////////////////////////////////////////
//DATA LOADING
////////////////////////////////////////////////////////////

// load in the data
LoadWave/J/D/W/K=0 "Macintosh HD:Users:KurtisBroda:Google Drive:SP2 UAlberta experiment:Time_Mass_CSV:Filtered_20151208_41_65_Time_Mass.csv"
  Delimited text load from "Filtered_20151208_41_65_Time_Mass.csv"
  Data length: 602704, waves: BCmass, TimeDate
Edit BCmass,TimeDate

//display a graph
Display BCmass vs TimeDate
ModifyGraph mode=2,lsize=0.5,rgb=(65535,0,0)

 
 
 
 
 
 ////////////////////////////////////////////////////////////
//PLOTTING THE 
////////////////////////////////////////////////////////////
 
 

//Load the edges of the midpoint vector
//"Macintosh HD:Users:KurtisBroda:OneDrive:M.Sc. Research:Data:Inversion_good_data:CHAM1001Mass_concentrations"

macro load2Dplot()
LoadWave/J/M/D/N=no_coating_midpoints/O/K=0 "Macintosh HD:Users:KurtisBroda:OneDrive:M.Sc. Research:Data:Inversion_good_data:CHAM1001edges_midpoints" 
LoadWave/J/M/D/N=no_coating_mbin/O/K=0 "Macintosh HD:Users:KurtisBroda:OneDrive:M.Sc. Research:Data:Inversion_good_data:CHAM1001edges_m_bin"
LoadWave/J/M/D/N=no_coating_dndn/O/K=0 "Macintosh HD:Users:KurtisBroda:OneDrive:M.Sc. Research:Data:Inversion_good_data:CHAM1001dN2_dlog_mp_rBC"
LoadWave/J/M/D/N=no_coating_chi/O/K=0 "Macintosh HD:Users:KurtisBroda:OneDrive:M.Sc. Research:Data:Inversion_good_data:CHAM1001chi value"
LoadWave/J/M/D/N=no_coating_M/O/K=0 "Macintosh HD:Users:KurtisBroda:OneDrive:M.Sc. Research:Data:Inversion_good_data:CHAM1001Mass_concentrations"


LoadWave/J/M/D/N=coating_midpoints/O/K=0 "Macintosh HD:Users:KurtisBroda:OneDrive:M.Sc. Research:Data:Inversion_good_data:CHAM1016edges_midpoints" 
LoadWave/J/M/D/N=coating_mbin/O/K=0 "Macintosh HD:Users:KurtisBroda:OneDrive:M.Sc. Research:Data:Inversion_good_data:CHAM1016edges_m_bin"
LoadWave/J/M/D/N=coating_dndn/O/K=0 "Macintosh HD:Users:KurtisBroda:OneDrive:M.Sc. Research:Data:Inversion_good_data:CHAM1016dN2_dlog_mp_rBC"
LoadWave/J/M/D/N=coating_chi/O/K=0 "Macintosh HD:Users:KurtisBroda:OneDrive:M.Sc. Research:Data:Inversion_good_data:CHAM1016chi value"
LoadWave/J/M/D/N=coating_M/O/K=0 "Macintosh HD:Users:KurtisBroda:OneDrive:M.Sc. Research:Data:Inversion_good_data:CHAM1016Mass_concentrations"

LoadWave/J/M/D/N=mix_coating_midpoints/O/K=0 "Macintosh HD:Users:KurtisBroda:OneDrive:M.Sc. Research:Data:Inversion_good_data:CHAM1017edges_midpoints" 
LoadWave/J/M/D/N=mix_coating_mbin/O/K=0 "Macintosh HD:Users:KurtisBroda:OneDrive:M.Sc. Research:Data:Inversion_good_data:CHAM1017edges_m_bin"
LoadWave/J/M/D/N=mix_coating_dndn/O/K=0 "Macintosh HD:Users:KurtisBroda:OneDrive:M.Sc. Research:Data:Inversion_good_data:CHAM1017dN2_dlog_mp_rBC"
LoadWave/J/M/D/N=mix_coating_chi/O/K=0 "Macintosh HD:Users:KurtisBroda:OneDrive:M.Sc. Research:Data:Inversion_good_data:CHAM1017chi value"
LoadWave/J/M/D/N=mix_coating_M/O/K=0 "Macintosh HD:Users:KurtisBroda:OneDrive:M.Sc. Research:Data:Inversion_good_data:CHAM1017Mass_concentrations"
end

////////////////////////////////////////////////////////////
//PLOTTING
////////////////////////////////////////////////////////////
macro plotall()
//CASE 1:  the mixture of coatings 
	mix_coating_midpoints0 = mix_coating_midpoints0*1e18  //we want to plot everything in femtograms
	mix_coating_mbin0 = mix_coating_mbin0*1e18  //we want to plot everything in femtograms
	
	//Make the one to one line, for the extent of our data
	Make/O/N=2 onetwoy_mix //make the yvalues of the waves
	Make/O/N=2 onetwox_mix //make the xvalues of the waves
	onetwoy_mix(0) = wavemin(mix_coating_midpoints0)
	onetwoy_mix(1) = wavemax(mix_coating_midpoints0)
	// a one to one line, set the x values the same as the y values
	onetwox_mix(0) = onetwoy_mix(0)
	onetwox_mix(1) = onetwoy_mix(1)

	//Remove the non-real values
	//removeNonRealMasses(mix_coating_mbin0, mix_coating_midpoints0, mix_coating_dndn0)
	
	Display /W=(200,200,900,800)/VERT onetwox_mix vs onetwoy_mix
	AppendImage mix_coating_dndn0 vs {mix_coating_midpoints0,mix_coating_mbin0}
	ModifyImage mix_coating_dndn0 ctab= {*,*,Rainbow,1}
	ModifyGraph lSize=5
	ModifyGraph lStyle=8
	ModifyGraph rgb=(65535,65535,65535)
	ModifyGraph log=1
	ModifyGraph tick=2
	ModifyGraph mirror=1
	ModifyGraph fSize=20
	ModifyGraph fStyle=1
	ModifyGraph lblMargin(left)=5,lblMargin(bottom)=18
	ModifyGraph standoff=0 
	ModifyGraph axThick=2
	ModifyGraph lblLatPos(left)=16,lblLatPos(bottom)=15
	ModifyGraph axisOnTop=1
	Label left "\\F'Helvetica'\\Z24\\f02m\\B\\f00p \\M \\Z24 (fg)"
	Label bottom "\\F'Helvetica'\\Z24\\f02m\\B\\f00rBC \\M \\Z24 (fg)"
	SetAxis left 1,100
	SetAxis bottom 1,100
	ColorScale/C/N=text0/D={2,1,0}/A=LT/X=3.97/Y=2.24 image=mix_coating_dndn0
	ColorScale/C/N=text0 frame=2, heightPct=35, widthPct=5, tickThick=2, fsize=18
	ColorScale/C/N=text0 fstyle=1, logLTrip=0.1, notation=1, axisRange={NaN,20000,0}
	AppendText "\\F'Helvetica'\\Z24\\f00#\\S2\\M \\Z24cm\\S-6"
	ModifyGraph swapXY=1
	ModifyGraph fSize=18
	
	
//CASE 2: for a coated particle
	coating_midpoints0 = coating_midpoints0*1e18  //we want to plot everything in femtograms
	coating_mbin0 = coating_mbin0*1e18  //we want to plot everything in femtograms
	
	//Make the one to one line, for the extent of our data
	Make/O/N=2 onetwoy_coating //make the yvalues of the waves
	Make/O/N=2 onetwox_coating //make the xvalues of the waves
	onetwoy_coating(0) = wavemin(coating_midpoints0)
	onetwoy_coating(1) = wavemax(coating_midpoints0)
	// a one to one line, set the x values the same as the y values
	onetwox_coating(0) = onetwoy_coating(0)
	onetwox_coating(1) = onetwoy_coating(1)
	
	//removeNonRealMasses(coating_mbin0, coating_midpoints0, coating_dndn0)

	Display /W=(200,200,900,800)/VERT onetwox_coating vs onetwoy_coating
	AppendImage coating_dndn0 vs {coating_midpoints0,coating_mbin0}
	ModifyImage coating_dndn0 ctab= {*,*,Rainbow,1}
	ModifyGraph lSize=5
	ModifyGraph lStyle=8
	ModifyGraph rgb=(65535,65535,65535)
	ModifyGraph log=1
	ModifyGraph tick=2
	ModifyGraph mirror=1  
	ModifyGraph fSize=20
	ModifyGraph fStyle=1
	ModifyGraph lblMargin(left)=5,lblMargin(bottom)=18
	ModifyGraph standoff=0
	ModifyGraph axThick=2
	ModifyGraph lblLatPos(left)=16,lblLatPos(bottom)=15
	ModifyGraph axisOnTop=1
	Label left "\\F'Helvetica'\\Z24\\f02m\\B\\f00p \\M \\Z24 (fg)"
	Label bottom "\\F'Helvetica'\\Z24\\f02m\\B\\f00rBC \\M \\Z24 (fg)"
	SetAxis left 1,100
	SetAxis bottom 1,100
	ColorScale/C/N=text0/D={2,1,0}/A=LT/X=3.97/Y=2.24 image=coating_dndn0
	ColorScale/C/N=text0 frame=2, heightPct=35, widthPct=5, tickThick=2, fsize=18
	ColorScale/C/N=text0 fstyle=1, logLTrip=0.1, notation=1, axisRange={NaN,20000,0}
	ColorScale/C/N=text0 axisRange={,25000}
	AppendText "\\F'Helvetica'\\Z24\\f00#\\S2\\M \\Z24cm\\S-6"
	ModifyGraph swapXY=1
	ModifyGraph fSize=18
	
//CASE 3: for a non-coated particle
	no_coating_midpoints0 = no_coating_midpoints0*1e18  //we want to plot everything in femtograms
	no_coating_mbin0 = no_coating_mbin0*1e18  //we want to plot everything in femtograms
	
//Make the one to one line, for the extent of our data
	Make/O/N=2 onetwoy_no_coating //make the yvalues of the waves
	Make/O/N=2 onetwox_no_coating //make the xvalues of the waves
	onetwoy_no_coating(0) = wavemin(no_coating_midpoints0)
	onetwoy_no_coating(1) = wavemax(no_coating_midpoints0)
	// a one to one line, set the x values the same as the y values
	onetwox_no_coating(0) = onetwoy_no_coating(0)
	onetwox_no_coating(1) = onetwoy_no_coating(1)
	
	//removeNonRealMasses(no_coating_mbin0, no_coating_midpoints0, no_coating_dndn0)
	
	Display /W=(200,200,900,800)/VERT onetwox_no_coating vs onetwoy_no_coating
	AppendImage no_coating_dndn0 vs {no_coating_midpoints0,no_coating_mbin0}
	ModifyImage no_coating_dndn0 ctab= {*,*,Rainbow,1}
	ModifyGraph lSize=5
	ModifyGraph lStyle=8
	ModifyGraph rgb=(65535,65535,65535)
	ModifyGraph log=1
	ModifyGraph tick=2
	ModifyGraph mirror=1
	ModifyGraph fSize=20
	ModifyGraph fStyle=1
	ModifyGraph lblMargin(left)=5,lblMargin(bottom)=18
	ModifyGraph standoff=0
	ModifyGraph axThick=2
	ModifyGraph lblLatPos(left)=16,lblLatPos(bottom)=15  
	ModifyGraph axisOnTop=1
	Label left "\\F'Helvetica'\\Z24\\f02m\\B\\f00p \\M \\Z24 (fg)"
	Label bottom "\\F'Helvetica'\\Z24\\f02m\\B\\f00rBC \\M \\Z24 (fg)"
	SetAxis left 1,100
	SetAxis bottom 1,100
	ColorScale/C/N=text0/D={2,1,0}/A=LT/X=3.97/Y=2.24 image=no_coating_dndn0
	ColorScale/C/N=text0 frame=2, heightPct=35, widthPct=5, tickThick=2, fsize=18
	ColorScale/C/N=text0 fstyle=1, logLTrip=0.1, notation=1, axisRange={NaN,20000,0}
	ColorScale/C/N=text0 axisRange={,40000}
	AppendText "\\F'Helvetica'\\Z24\\f00#\\S2\\M \\Z24cm\\S-6"
	ModifyGraph swapXY=1
	ModifyGraph fSize=18
	
	end
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////FUNCTIONS///////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
	
////////////////////////////////////////////////////////////
//REMOVE NON REAL VALUES AND PLOT THEM AS ZERO
////////////////////////////////////////////////////////////

Duplicate/O no_coating_dndn0, testWave
	
Make/O/N=(DimSize(testWave,1)+1) testMatrixX = (p+1)/10
Make/O/N=(DimSize(testWave,0)+1) testMatrixY = (p+1)/10
	
Print removeNonRealMasses(testMatrixX, testMatrixY, testWave)
	
Function removeNonRealMasses(xValues, yValues, NumDist2D)
	// note that xvalues and yvalues are the edges of the bins, we need them for plotting
	wave xValues
	wave yValues
	wave NumDist2D
	Variable numRows = DimSize(NumDist2D,0)
	Variable numCols = DimSize(NumDist2D,1)
	Variable jj
	Variable ii
	
	Make/O/N=(DimSize(xValues,0)-1) mbin
	Make/O/N=(DimSize(yValues,0)-1) midpoints
	
	//the mp's are the midpoints of the xValues
	for (ii=0;ii<DimSize(xValues,0)-1;ii+=1)
	mbin[ii] = (xValues(ii)+xValues(ii+1))/2
	endfor
	
	for (ii=0;ii<DimSize(yValues,0)-1;ii+=1)
	midpoints[ii] = (yValues(ii)+yValues(ii+1))/2
	endfor	
	
	print midpoints
	print mbin
	
	//Make a matrix to check which rows are not real
	Make/O/N=(numRows,numCols) temp 
 	
 	for (ii=0;ii<numCols-1;ii+=1)
 		for(jj=0;jj<numRows;jj+=1)
 		temp[jj][ii] = xValues(ii+1) - yValues(jj)
 			if (temp[jj][ii]<0)
 				NumDist2D[jj][ii] = 0
 			endif
 		endfor
 	endfor
 	print temp
 	//print NumDist2D
 	//return NumDist2D
 	
end



//// Kills all the graphs
//Function KillAllGraphs()
//	string fulllist = WinList("*", ";","WIN:1")
//	string name, cmd
//	variable i
// 
//	for(i=0; i<itemsinlist(fulllist); i +=1)
//		name= stringfromlist(i, fulllist)
//		sprintf  cmd, "Dowindow/K %s", name
//		execute cmd		
//	endfor
//end

HeyBuddy(coating_dndn0,coating_midpoints0,coating_mbin0,onetwox_coating,onetwoy_coating)

Function HeyBuddy(dNdN,midpoints,mbin,onetwox,onetwoy)
	wave onetwox,onetwoy,midpoints,mbin,dNdN
	print dNdN
	Display /W=(342.75,49.25,840.75,482)/VERT onetwox vs onetwoy
	AppendImage dNdN vs {midpoints,mbin}
	ModifyImage mix_coating_dndn0 ctab= {*,*,Rainbow,1}
	ModifyGraph lSize=5
	ModifyGraph lStyle=8
	ModifyGraph rgb=(65535,65535,65535)
	ModifyGraph log=1
	ModifyGraph tick=2
	ModifyGraph mirror=1
	ModifyGraph fSize=20
	ModifyGraph fStyle=1
	ModifyGraph lblMargin(left)=5,lblMargin(bottom)=18
	ModifyGraph standoff=0
	ModifyGraph axThick=2
	ModifyGraph lblLatPos(left)=16,lblLatPos(bottom)=15
	ModifyGraph axisOnTop=1
	Label left "\\Z24m\\Bp \\M \\Z24 (fg)"
	Label bottom "\\Z24m\\Bp \\M \\Z24 (fg)"
	SetAxis left 1,100
	SetAxis bottom 1,100
	ColorScale/C/N=text0/D={2,1,0}/A=LT/X=3.97/Y=2.24 image=dNdN
	ColorScale/C/N=text0 frame=2, heightPct=35, widthPct=5, tickThick=2, fsize=18
	ColorScale/C/N=text0 fstyle=1, logLTrip=0.1, notation=1, axisRange={NaN,20000,0}
	AppendText "\\Z24 #\\S2\\M \\Z24cm\\S-6"
	ModifyGraph swapXY=1
End



